import { type BuiltinObjectKind, type Constructor } from "@ark/util";
import type { BaseErrorContext, BaseNormalizedSchema, declareNode } from "../shared/declare.ts";
import { type nodeImplementationOf } from "../shared/implement.ts";
import { type JsonSchema } from "../shared/jsonSchema.ts";
import type { TraverseAllows } from "../shared/traversal.ts";
import { InternalBasis } from "./basis.ts";
export declare namespace Proto {
    type Reference = Constructor | BuiltinObjectKind;
    type Schema<proto extends Reference = Reference> = proto | ExpandedSchema<proto>;
    interface NormalizedSchema<proto extends Constructor = Constructor> extends BaseNormalizedSchema {
        readonly proto: proto;
    }
    interface ExpandedSchema<proto extends Reference = Reference> {
        readonly proto: proto;
    }
    interface Inner<proto extends Constructor = Constructor> {
        readonly proto: proto;
    }
    interface ErrorContext extends BaseErrorContext<"proto">, Inner {
    }
    interface Declaration extends declareNode<{
        kind: "proto";
        schema: Schema;
        normalizedSchema: NormalizedSchema;
        inner: Inner;
        errorContext: ErrorContext;
    }> {
    }
    type Node = ProtoNode;
}
export declare class ProtoNode extends InternalBasis<Proto.Declaration> {
    builtinName: BuiltinObjectKind | null;
    serializedConstructor: string;
    compiledCondition: string;
    compiledNegation: string;
    protected innerToJsonSchema(): JsonSchema.Array;
    traverseAllows: TraverseAllows;
    expression: string;
    readonly domain = "object";
    get shortDescription(): string;
}
export declare const Proto: {
    implementation: nodeImplementationOf<Proto.Declaration>;
    Node: typeof ProtoNode;
};
